<?php

namespace Drupal\cmlmigrations\Plugin\migrate\source;

use Drupal\cmlmigrations\Utility\MigrationsSourceBase;
use Drupal\migrate\Plugin\MigrationInterface;

/**
 * Source for CSV.
 *
 * @MigrateSource(
 *   id = "cml_commerce_product_variation_attribute"
 * )
 */
class CommerceProductVariationAttribute extends MigrationsSourceBase {

  /**
   * {@inheritdoc}
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition, MigrationInterface $migration) {
    $this->fetch = FALSE;
    $this->debug = FALSE;
    parent::__construct($configuration, $plugin_id, $plugin_definition, $migration);
  }

  /**
   * {@inheritdoc}
   */
  public function getRows() {
    $rows = [];
    $source = \Drupal::service('cmlapi.parser_offers')->parse();
    $trans = \Drupal::transliteration();
    if ($source) {
      $k = 0;
      foreach ($source as $key => $row) {
        if ($k++ < 100 || !$this->uipage) {
          if (!empty($row['KHarakteristikiTovara'])) {
            foreach ($row['KHarakteristikiTovara'] as $attribute) {
              $name = $trans->transliterate($attribute['Наименование'], '');
              if (array_key_exists($name, $this->attributes)) {
                $name = $this->attributes[$name];
                $value = $attribute['Значение'];
                $id = "$name-$value";
                $rows[$id] = [
                  'uuid' => $id,
                  'attribute' => $name,
                  'name' => $value,
                  'weight' => 0,
                ];
              }
            }
          }
        }
      }
    }
    $this->debug = FALSE;
    return $rows;
  }

}
